#
# urbi-boost.m4: This file is part of build-aux.
# Copyright (C) 2010, Gostai S.A.S.
#
# This software is provided "as is" without warranty of any kind,
# either expressed or implied, including but not limited to the
# implied warranties of fitness for a particular purpose.
#
# See the LICENSE file for more information.
# For comments, bug reports and feedback: http://www.urbiforge.com
#

m4_pattern_forbid([^URBI_])

AC_PREREQ([2.60])

# URBI_BOOST_REQUIRE([VERSION = 1.38])
# ------------------------------------
# This macro should be called before URBI_LIBPORT.
AC_DEFUN([URBI_BOOST_REQUIRE],
[AC_BEFORE([$0], [_URBI_LIBPORT_BOOST])dnl
BOOST_REQUIRE(m4_default([$1], [1.38]))
if $COMPILATION_MODE_DEBUG; then
  boost_rt_opt=gd
fi

# Use only shlibs.  See autolinking feature used by Boost to require
# from the compiler to link specific libraries (yes, via special
# #pragmas in the headers).
case $CXX_FLAVOR in
  (msvc) URBI_APPEND_CPPFLAGS([-DBOOST_ALL_DYN_LINK]);;
esac
])

# URBI_BOOST(COMPONENT)
# ---------------------
# For instance "URBI_BOOST([TEST])" instead of BOOST_TEST.
AC_DEFUN([URBI_BOOST],
[AC_REQUIRE([URBI_BOOST_REQUIRE])dnl
BOOST_$1([$boost_rt_opt])
])

## Local Variables:
## mode: Autoconf
## End:
