## Copyright (C) 2009-2010, Gostai S.A.S.
##
## This software is provided "as is" without warranty of any kind,
## either expressed or implied, including but not limited to the
## implied warranties of fitness for a particular purpose.
##
## See the LICENSE file for more information.

include uobjects/uobjects.mk

EXTRA_DIST += $(addprefix uobjects/,$(UOBJECTS:=.uob))

# _SCRIPTS so that we preserve the executable bit.
uobjects_SCRIPTS = $(addprefix uobjects/,$(UOBJECTS:=$(DLMODEXT)))
CLEANFILES += $(uobjects_DATA) $(uobjects_DATA:$(DLMODEXT)=.la)

UMAKE_SHARED = tests/bin/umake-shared

%$(DLMODEXT): %.uob $(UMAKE_SHARED) libuobject/libuobject$(LIBSFX).la
	$(UMAKE_SHARED) --clean --output=$@ $<
## umake has dependencies support, so it might not recompile here, in
## which case, if this was triggered because of $(UMAKE_SHARED) we
## will keep on cycling.
	touch $@

clean-local: clean-uobjects
clean-uobjects:
# If we are unlucky, umake-shared will be cleaned before we call it.
# When clean is concurrent, we might even have "rm" be given
# directories that no longer exist.  So forget about the exit status.
	-$(UMAKE_SHARED) --deep-clean ||			\
	  find uobjects -name "_ubuild-*" -a -type d | xargs rm -rf
# This is a bug in deep-clean: we don't clean the .libs files.  But it
# is not so simple, as several builds may share a common .libs, so one
# build cannot remove this directory.
	-find uobjects -name ".libs" -a -type d | xargs rm -rf
	-rm -f $(uobjects_DATA) $(uobjects_DATA:$(DLMODEXT)=.la)

# Help to restart broken builds.
$(UMAKE_SHARED):
	$(MAKE) $(AM_MAKEFLAGS) -C tests bin/umake-shared
	$(MAKE) $(AM_MAKEFLAGS) -C $(top_builddir) sdk/umake-shared sdk/umake


## -------------- ##
## installcheck.  ##
## -------------- ##

# Check that we can clean and make again the UObjects with the
# installed SDK Remote, not the build one.
installcheck installcheck-html: installcheck-umake
installcheck-umake:
	PATH="$(DESTDIR)$(bindir):$$PATH" &&				      \
	  $(MAKE) $(AM_MAKEFLAGS) UMAKE_SHARED=umake-shared clean-uobjects && \
	  $(MAKE) $(AM_MAKEFLAGS) UMAKE_SHARED=umake-shared $(uobjects_DATA)
